[up](squid.md) [back](squid-chain.md) [next](squid-fed.md)

_“Mining” (or better called “Minting“) is the process of creating coins (money
in circulation). It shall not be confused with earning money, where no new
coins are created, just existing coins are transferred._

# The $quid: Useful Investment & Ethical Mining

_What valuable to base a crypto currency on? Or what is a worse crime
than robbing a bank?  What's worse than inventing a crypto currency?_

People who defend BitCoins against the “it's a bubble” argument told
me they think of this (and of ICOs of other crypto currency projects)
as investment into a technology.  I doubt that Satoshi Nakamoto will
actually sell his coins, so it doesn't quite work, but I'm fine with
the idea of investment as such.

I therefore propose a useful speculation object for humans who like
the proof of work concept to back a currency (not to back the security
of the transactions!) that is in the collection of cowry shells and
the mining of gold, or in good rules for fiat money, which are also
backed by big, real economies, and the real work that happens there.
The common idea between these concepts is that they are valuable,
because it is hard work to obtain them.  And once you have them, you
can exchange them for other goods that are equally hard work, and they
retain their value.

But first, I want to explain the name: $quid a combination of the $
symbol (pronounced simply “S” here), and the word quid.  Quid is a
word for a metal-backed currency, the pound sterling (240 pennies of
silver of sterling quality are a imperial pound).  But it also is the
first word in “quid pro quo”, a very important concept in society, and
the foundation why trade actually works.  It's about cooperative
behavior even when the persons participating are egoists, forced by
game theory to be cooperative.  But after all, “quid” on its own just
means “what?“, a question always valid to ask.

One thing we have in society that lacks a bit quid pro quo is free
software development.  You give, people take, most of them without
giving back.  Developers participating in free software development
take and give back, and that's why we do it: We all stand on the
shoulders of others.  Even if you scroll through the licenses of a
proprietary OS like iOS, you see an amazing amount of free software
that has been used there.  The value of free software is incredible.

So how do you mine $quids?  You create useful free software, and then
you get the right to issue $quids.  It's up to organizations like the
Linux Foundation or the GNU project to figure out who qualifies and if
the amount of work that allegedly went into the project is plausible,
this supervision will avoid fraud; but the market liberals probably
would suggest that a bidding system like for ICOs (initial coin
offerings) is completely sufficient.  You could have a combination of
both: Bidding and evaluation plus recommendation from trustworthy
organizations.  Of course, like BitCoin, the $quid is an experiment,
and the number of $quids that can go onto that market depend on the
acceptance.  If the acceptance is high, many projects will ask for
funding, if it's low, few, so the value of the $quid is
self-stabilizing.

A bidding system would work like this: _n_ $quids are offered.  When
you buy _m,_ you also offer a factor _x>1._ The buyers are sorted by
factor, and the highest bidder gets his _x*m_ $quids, paying _x*m_ the
price of a nominal $quid, but that deduces just _m_ from the offered
_n,_ so more $quids are generated from higher biddings.  High bidding
thus makes other projects want to be funded through that channel, so
it increases the amount of coins quickly.  Low bidding makes that
funding channel unattractive.

The difference between normal sponsorship and this approach is that
while the issuers of $quids get paid for their work, the people who
pay can trade the $quid, like investors in corporations can sell
stocks.  And while the effort of a corporation to develop proprieatary
software is ultimately lost to humanity, and the pay-back for the
investors is through profits, the effort of free software developers
is not lost; it can be shared and it can be used to improve and base
upon; so paying them and still having the $quid as currency to trade
is a fair deal: Society as a whole got richer through the creation of
free software, so increasing the amount of money in circulation is ok.
I view free software as infrastructure, and investment in
infrastructure pays off for the entire economy.  Increasing the amount
of liquidity therefore is a good way to finance infrastructure.

Free software is a non-rivalrous good.  You can copy it as much as you
like, you can change it and fit it to your purpose (supposed it is
constructed lean enough, and you have the qualification for doing
that), so it's not reasonable to trade it on its own.  The whole
concept behind copyright to turn knowledge and wisdom into rivalrous
goods is a bad idea.  To society, they are much more worth when they
are non-rivalrous.

So therefore I propose to turn the sponsorship of free software development
effort, which is a scarce resource (both the sponsorship itself and the
development), and creates knowledge (public infrastructure of the information
age), into a tradeable currency, and thereby make this work valuable in a
classical free market economy sense — just like your summer's harvest can be
traded already in winter by means of a “future”.  Instead of financing startups,
which are classical economy, the initial $quid offer goes into work for the
public.

To take out coins that are no longer good use for circulation, I propose that
they can be used as donation receipt to get a tax deduction. Ideally, the free
market would then shift the tax deduction to countries with very high taxes
and rich people who are very eager to get a tax deduction.

_Ah, yes, and penguins eat squids, too._

[up](squid.md) [back](squid-chain.md) [next](squid-fed.md)
