[up](squid.md) [back](squid-bingo.md) [next](squid-pow.md)

# Purpose of a currency (with history lesson)

_Where does the need for money come from?  And what's money?_

We'll mostly look into Chinese history, because all the important
inventions in currencies happened there.  Except maybe the cowry shell
money, but we don't know.

### Terms

* Commodity money: Objects with inherent value used as money
* Representative money: Note promising exchange with objects with
  inherent values used as money (also: promissory notes)
* Fiat money: Medium with no inherent value and no promise for
  exchange with such an object used as money
* Legal tender: Medium of payment by law, can be any of the above

People tend to confuse legal tender with fiat money, because nobody
would accept a fiat money if it's not a legal tender.  Or would you?
So the common English definition of “fiat money” implies that it is a
legal tender.

### Early forms of money

Stone age society started with share economy: When you had something
in abundance, you'd share it with your larger family, the small tribe
you were associated with.  You'd expect the other members to share
their prey or whatever they had to share with you, too.  You can do
that, because there's trust and established relationship.

When society grew larger, this no longer worked.  You would trade
things, e.g. meat vs. plants or tools.  The obvious problem with that
is: you need to find someone who has a need for your thing and at the
same time provides something you have a need for.

That could be solved by exchanging tokens that everybody considered
valuable, that were easy to carry, but rare enough nobody could get
them too easily: That is the birth of money.  The first known money
mankind used (earliest at least 30000 years ago) was “shell money” or
“cowry money”, shells of maritime snails (in Chinese: 貝/贝 “bei”,
still means “money” as well as “cowry”).  They were picked up at the
shore, so you had to invest a certain amount of work to get them.

Shell money was the more valuable the further away from the shore, so
when metallurgy was invented, the people from the mountain came up
with shiny metal coins as hard to get but easy to carry and
longlasting valuables, creating silver and gold standards for
currencies.  Both shells and noble metals can serve as jewellery, so
it's not completely useless, but the main purpose for money is a proxy
for exchanged values, so you can exchange the things you have and the
things you need with different persons.  The money itself decouples
the individual acts of trade.

The work to get the shell or the coin is only invested once, but the
coin remains an interchangeable object of value, it can be traded many
times.

### Banknotes

These scarce tokens were chosen to ensure that you need a certain
amount of work to gather them, so when your time has a value, you
wouldn't waste too much on collecting shells or mining gold.  The
problem is: these things have an upper limit of availability (even if
more people collect or mine them), and when society and economy grows,
you run out of tokens, and grafting more just for the sake to haven
enough coins is a waste of ressources: You'd rather spend your time
with the actual real products, instead of running after the next gold
rush.

This leads to deflation, and in deflation, people tend to hoard
their money (spending it tomorrow gets you more than spending today),
which creates an economic downcycle, and deflation gets worse.  If it
was just lack of work to get the tokens, society would ramp up
collecting shells and mining noble metals, but if there is a natural
limit to get more shells or gold, you need another idea.

The first early forms of banknotes were financial products, the
promissory note.  Instead of actually paying, you just gave the
promise.  That allows to inflate the amount of available money to keep
business going, because now almost any valuable, even real estate,
could be converted into easy to carry paper.  Song dynasty China
e.g. had a booming economy (with an estimated 200 billion coins
minted), and the availability of cash to exchange the vast amount of
traded goods was always a problem, even with this large amount of
minted coins.

The earliest form of banknotes were check-like promissory notes,
issued by banks, which promised coins in exchange; the notes themself
(飞钱, feiqian, flying money) were very popular due to the shortage of
actual coins.  In the late Tang dynasty the first such notes appeared,
and became quickly popular.

![feiqian](https://gss3.bdstatic.com/-Po3dSag_xI4khGkpoWK1HF6hhy/baike/c0%3Dbaike92%2C5%2C5%2C92%2C30/sign=fa7e505f8b025aafc73f76999a84c001/359b033b5bb5c9ea3ea3157cdc39b6003bf3b3d8.jpg)

These notes were produced and cashed in by banks.  In 1024, the first
state-issued feiqians were issued, and in the 12th century (in the
southern Song dynasty), the 会子(huizi) was established as legal
tender.

![Huizi](https://upload.wikimedia.org/wikipedia/commons/6/6a/Hui_zi.jpg)

Song dynasty banknotes had similar properties to gold standard
dollars, they could be turned into metal coins.  And of course,
forgery became an issue, because the whole point of paper money is to
make it quick and easy to produce, and regulate the amount of money in
circulation by authoritive decisions, not by how much work was
available for doing that job.  The money got stamped with seals which
were difficult to make, but could be used for many notes, and can be
kept under control.  That is a proof of ownership and authority: You
can issue a note if you prove that you own the seal.  The seal owner
is not anonymous, it's a government clerk.

The Song dynasty's huizi was somehow experimental, and took care to
base the paper money's value on bronze (northern Song) and silver
(southern Song), with bronze price fluctuating a lot in southern Song.

The following mongolian Yuan dynasty took the concept further to the
first fiat money.  They didn't allow private ownership of silver and
gold (compare: Roosevelt's America after the great depression), so the
banknote was not a promise to give you noble metal.  Inflation was a
problem in both the Yuan dynasty and the early Ming dynasty following,
which stopped issuing banknotes in 1450; the circulating notes however
were still accepted — and the currency system was privatized,
i.e. they went back to the feiqian promissory notes.

Thanks to Marco Polo, Europe soon got a pretty good description of how
it worked, because Marco Polo as merchant was interested in this kind
of things.  One reason why the banknote didn't catch on at that time
was that neither paper nor a sufficiently good printing press were
invented here.  In the western world, banknotes were usually
exchangeable with noble metal coins until 1970, when Bretton Woods
broke.

However, most contemporary money transactions are no longer cash,
neither coins nor banknotes, they are “fiat money”, money that's only
in the books, and only has a promise to be exchanged with banknotes,
and the notes are not a promise to get you noble metal.

The act of creating “fiat money” is an act of state, the central bank
lends money to other banks, money it doesn't actually have, and when
it gets it back, it is removed from circulation.  This is something
that seems to be pretty difficult to understand, because the concept
of money used to be valuable tangible things, not numbers in an
electronic ledger.  And that it is a political decision how much money
to create or let disappear is of concern to those who don't trust
politicians — even if the lawmaker only sets rules for the conditions
to create and annihilate book money, it is unclear to many people why
these rules make sense.  A lot of early fiat money experiments ended
in hyperinflation, and a return to some noble metal standard.

However, the lessons were learned, and today, most fiat currencies are
pretty stable, and survive even major disruptions of the economy.
Money in the information age is just an entry in an electronic ledger.
It's backed by the economy, and it's availability is adjusted to keep
it pretty stable.

But the only security these ledgers have nowadays is that it require
physical access to the computers that hold it.  And we know how secure
computers are.  The idea of a crypto currency therefore is to provide
security of these ledgers through mathematical magic.

[up](squid.md) [back](squid-bingo.md) [next](squid-pow.md)
