[up](squid.md) [back](squid-pow.md) [next](squid-chain.md)

# Money and wealth — Society in a deflationary world

How money shapes a society, and why the limited supply of BitCoins is
far worse than neoliberalism.

## Speculation object

_Is BitCoin's price a bubble?  Who could have that strange idea?_

Typical spam I received 2016:

![Spam 2016](../doc/spam-2016.jpg)

The only spam I received late 2017:

![Spam 2017](../doc/spam-2017.jpg)

And that's how a bubble looks like:

![Stages in a bubble](https://people.hofstra.edu/geotrans/eng/ch7en/conc7en/img/stages_bubble.png)

Mammals like to gamble.  The reason for why gambling is so rewarding
has been found by B. F. Skinner.  Erratic, random reward reinforces
behavior better than constant, predictable.  Humans don't show any
more meta-insights than mice in this respect.

The pattern of gambling with speculation objects are remarkable
similar.  Even smart persons like Isaac Newton lost a fortune in
bursting bubbles.  The madness of humans however can be calculated,
though certainly not to the finest details.  The BitCoin chart however
looks like a classic:

![BitCoin Chart](https://assets.bwbx.io/images/users/iqjWHBFdfxIU/iFKLTQNYjslA/v4/800x-1.png)

Speculation bubbles don't mean the money disappears.  The money is
still there, it's just owned by someone else now; only if you include
the market cap of the speculation object, it disappeared.  Despite
that the total amount of money is constant through a speculation
bubble, they have a deep impact on economy.

That's because those who entered the bubble early and sold at the
right time got the money, and those who entered late lost.  The
tragedy is that the early ones are smart and rare, and the late ones
are stupid and many.  And that means a huge concentration in money,
and especially a loss for those who didn't really have that money,
causing them to default, and sink into poverty.  Speculation
inevitably is a move from the crowd to the few who behaved
differently, not necessarily smart; a counter-action to the crowd can
improve your chances of winning.  You shouldn't go to “buy high, sell
low”, though.

## BitCoin is Reactionary

But let's assume BitCoin is not a bubble going bust, but it's supposed
to last (all 21 millions), and used as currency for everything by
everybody.  That means the price per coin would soar until the total
market cap equals the wealth of the entire planet (plus hot air for
the first movers).  BitCoin's wealth allocation is that of
colonization or gold rushs: the first to arrive are the ones who get
the by far largest claims.

And that would mean all those people who were there in the early phase
would be incredible rich, just by being early.  Instead of creating
most coins in the last, big growth phase, BitCoin created them in the
early phase, where it was essentially worthless and no effort needed
to mine the coins.

So maybe that wealth is going to trickle down?  Trickle down however
doesn't work.  Money inherently trickles up.  In a deflationary
system, there is no decay of money; instead the money of the wealthy
becomes more and more just on its own.  They don't even have to invest
it to gain wealth.  The result will be an increasingly absurd
distribution of wealth, and all the assorted problems: economic power
leads to political power, corruption, tax cuts for the rich,
slavery-like work relationships, because only the rich can afford
hiring people; the poor can't.  The instability of deflationary money
leads to speculation bubbles, which burst, and this instability moves
the money even faster to the first movers, who don't lose anything in
the downcycles.

That's not what I think as future I want.  Fiat money has its
downsides, too; but mostly when the state that controls it is in deep
troubles, and fails to create or establish rules that work for the
greater good.

## Driving forces to servitude

Historical societies often had driven most of the population into one
or the other form of servitude.  Ownership of production means,
i.e. land in agricultural societies, factories in industrial
societies, and a strict copyright regime in a knowledge society are
means to give power to few and exploit the many.

Sometimes, the concentration of power is a natural consequence,
e.g. for industrial production, economy of scale results in
concentration of wealth and power.  Or, in medieval Europe, the choice
was either become a knight and serve the king (and that includes the
risk of being killed in the next war), or become a serf, and thus
being owned by the local knight.  Even when servitude was abolished, a
similar relation between gentry and tenants were common, and the
gentry makes sure that their political influence works to stabilize
their properties.

Fiat money requires an intermediary (banks) to distribute the money
handed out by the central bank; this gives a lot of power to the
banks.  Crypto currencies, which don't require banks, could lift that
bane, but the way they are constructed now, they just create a new,
worse one.

And finally, in the age of information, copyright and concepts like
“work for hire” (i.e. the copyright is handed over as part of an
employment contract) concentrate the available knowledge in the hand
of the few.  Since Bill Gates, the super-rich all base their wealth on
author's rights of things they actually didn't author.

## The (in)stability of spending money

When trade happens in an inflationary system, people buy quick,
because money is the hot potato.  That by itself increases the amount
of money in circulation, because there are more hot potato
transactions (money spent per time increases).  More demand increases
the prices, so the inflation accellerates.

If you don't print new money, the inflation will inevitable stop: The
increased prices now match the increased turnaround speed, and
inherent delays stop the speed to increase even more.  So people will
stop spending their money early, and return to normal (and first
consume the stocked goods).  That causes deflation, so people will
rather keep their money, instead of spending it, waiting for the price
to go down further.  Low demand causes the prices to go lower, indeed.
If you don't take out money of the system, the lower circulation speed
will find a stable point, too.

We know these periodic oscillations of prices in many parts of the
economy, they are a consequence of a badly regulated closed loop
system; they tend to oscillate if not properly compensated.  If the
compensation is very bad, the oscillation is high, and annoying
everybody.  Big osciallation is shifting wealth from the poor (who
can't survive the downturns) to the rich (who can).

To remove such oscillation by proper compensation is just solid
engineering.  We don't want pork cycles.

[up](squid.md) [back](squid-pow.md) [next](squid-chain.md)
